require('dotenv').config()
const port = process.env.PORT || 3000
const host = process.env.HOST || 'localhost'
const express = require('express')
const socketio = require('socket.io')
const sense = require('sense-hat-led').sync
const app = express()
app.get('/', (req, res) => res.sendStatus(200))
const server = app.listen(port, host, () => {
    console.log(`rpi sense hat server is running at http://${host}:${port}`)
})
const io = socketio(server, { cors: { origin: '*' } })

const R = [255, 0, 0]
const G = [0, 255, 0]
const B = [0, 0, 255]
const X = [0, 0, 0]
const O = [255, 255, 255]
const sensehat = {
    leds: [
        B, B, B, B, B, B, B, B,
        R, R, R, R, R, R, R, R,
        X, X, X, X, X, X, X, X,
        X, X, X, X, X, X, X, X,
        X, X, X, X, X, X, X, X,
        X, X, X, X, X, X, X, X,
        G, G, G, G, G, G, G, G,
        O, O, O, O, O, O, O, O,
    ]
}

// Sense HAT 初始化
sense.lowLight = true
sense.setRotation(180)
sense.clear([0, 0, 0])
sense.setPixels(sensehat.leds)

io.on('connection', (client) => {
    console.log(`client conncted: ${client.id}`)
    client.on('operation', (operation) => {
        if (operation.action == 'clear') {
            console.log('清屏幕')
            sense.clear()
            sensehat.leds.forEach(led => {
                led = X
            })
        }
    })
})

// io.on('connection', (client) => {
//     client.emit('leds', leds)
//     client.on('action', ({ action, x, y }) => {
//         console.log({ action, x, y })
//         switch (action) {
//             case 'on':
//                 sense.setPixel(Number(x), Number(y), color_blue)
//                 leds[y][x] = 1
//                 break
//             case 'off':
//                 sense.setPixel(Number(x), Number(y), [0, 0, 0])
//                 leds[y][x] = 0
//                 break
//             case 'hello':
//                 sense.flashMessage('HELLO', 1, color_blue)
//                 sense.clear()
//                 read_all_leds(0)
//                 break
//             case 'flash':
//                 sense.clear([255, 255, 255])
//                 setTimeout(sense.clear, 100)
//                 read_all_leds(0)
//                 break
//             case 'clear':
//                 sense.clear()
//                 read_all_leds(0)
//                 break
//             case 'temp':
//                 read_all_leds()
//                 get_rpis_info()
//                 break
//             default:
//                 break
//         }
//         io.emit('leds', leds)
//     })
// })

// function read_all_leds(value = null) {
//     const pixels = sense.getPixels()
//     for (let y = 0; y < 8; y++) {
//         for (let x = 0; x < 8; x++) {
//             leds[y][x] = value !== null ? value : sense.getPixel(x, y)[2] == 0 ? 0 : 1
//         }
//     }
// }
